/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

/* ADC SAR sequencer component header to access Vref value */
#include <ADC.h>

void sine_wave_period(int period_number, int sin_data[]);
void sine_wave(int sin_data[], int average_value);
void IDAC_1_SetValue2(uint32 value);

uint16 n_points = 512;

int main()
{
    int sin_data[n_points];
    
    // Start Opamp component 
    Opamp1_Start();
    Opamp2_Start();
    Opamp3_Start();
    Opamp4_Start();
    

    /* Start the IDAC component */
    IDAC_1_Start(); 
    
    /* Init and start sequencing SAR ADC */
    //ADC_Start();
    //ADC_StartConvert();
    
    // Start SCB UART TX+RX operation 
    UART_Start();

    // Sets Opamp power mode to High power 
    Opamp1_SetPower(Opamp1_HIGH_POWER);
    Opamp2_SetPower(Opamp2_HIGH_POWER);
    Opamp3_SetPower(Opamp3_HIGH_POWER);
    Opamp4_SetPower(Opamp4_HIGH_POWER);
    
    sine_wave(sin_data, 60);
    
    sine_wave_period(200000000, sin_data);
    
    for(;;)
    {   

    }
    
}

void sine_wave_period(int period_number, int sin_data[]){
    
    int i;    
    int j;
    
    /*
    char snum[10];
    char snum2[10];
    int32 num = 0;
    int32 num2 = 0;
    */
    
    //UART_UartPutString("\nSTART\n\r");
    
    for (j = 1; j <= period_number; j++)
    {
        
        /*
        UART_UartPutString("\n\r");
        UART_UartPutString("-------------");
        UART_UartPutString("\n\r");
        */
        
        for (i = 0; i <= n_points-1; i++)
        {   
            IDAC_1_SetValue2(sin_data[i]);   
        
            /*
            num = ADC_GetResult16(0);      
       
            num2 = ADC_CountsTo_mVolts(0, num);

            itoa(num2, snum, 10);
            UART_UartPutString("\n\r");
            UART_UartPutString(snum);    
            UART_UartPutString(" mV\n\r");             
            itoa(sin_data[i], snum2, 10);            
            UART_UartPutString(snum2);
            UART_UartPutString(" sin_data[i]\n\r");
            */
            
        }
    }
}

void sine_wave(int sin_data[], int average_value){
    
    float pi = 3.141592;
    float w ;    
    float yi ;
    float phase = 0;
    int sign_samp; 
    int i;    
        
    w= 2*pi;
    w= w/n_points;                
        
    for (i = 0; i <= n_points-1; i++)
    {   
        yi= average_value*sin(phase);
        phase=phase+w;
        sign_samp=average_value+yi; 
        sin_data[i]=sign_samp;
        
    }
}


void IDAC_1_SetValue2(uint32 value)
{
    uint8 enableInterrupts;
    uint32 newRegisterValue;

    enableInterrupts = CyEnterCriticalSection();

    #if(IDAC_1_IDAC_VALUE_POSITION != 0u)
        newRegisterValue = ((IDAC_1_IDAC_CONTROL_REG & (~(uint32)((uint32)IDAC_1_IDAC_VALUE_MASK <<
        IDAC_1_IDAC_VALUE_POSITION))) | (value << IDAC_1_IDAC_VALUE_POSITION));
    #else
        newRegisterValue = ((IDAC_1_IDAC_CONTROL_REG & (~(uint32)IDAC_1_IDAC_VALUE_MASK)) | value);
    #endif // IDAC_1_IDAC_VALUE_POSITION != 0u 

    IDAC_1_IDAC_CONTROL_REG = newRegisterValue;

    CyExitCriticalSection(enableInterrupts);
}

